<script lang="ts">
  import { GameState, Phase } from "./domain";

  import { sortedBy } from "./utils";

  export let game: GameState;

  $: players = sortedBy(game.players(), (a, b) => b.score() - a.score());
</script>

<table>
  <thead>
    <tr>
      <th />
      <th />
      {#each Array(game.roundsPlayed()) as _, roundIdx}
        <th>Round {roundIdx + 1}</th>
      {/each}
      {#if game.phase() === Phase.GameEnd}
        <th>Dessert</th>
      {/if}
      <th>Total</th>
    </tr>
  </thead>
  <tbody>
    {#each players as player}
      <tr>
        <td />
        <td class="player-name">
          <gs6-user userid={player.id()} />
        </td>
        {#each Array(game.roundsPlayed()) as _, roundIdx}
          <td class="points">
            {player.roundScore(roundIdx)}
          </td>
        {/each}
        {#if game.phase() === Phase.GameEnd}
          <td class="points">
            {player.dessertScore()}
          </td>
        {/if}
        <td class="points">{player.score()}</td>
      </tr>
    {/each}
  </tbody>
</table>

<style>
  table {
    border-collapse: collapse;
    text-align: center;
  }

  th,
  td {
    white-space: nowrap;
  }

  th {
    border-bottom: 1px solid #aaaa;
    padding-bottom: 0.5em;
  }

  td:last-child,
  th:last-child {
    border-left: 1px solid #aaaa;
  }

  tbody td {
    padding-top: 0.5em;
  }
  .player-name {
    text-align: left;
  }
  .points {
    min-width: 4.5em;
    text-align: center;
  }
</style>
